//
//  FLHomeBodyView.m
//  TestLinkage
//
//  Created by Fingerfive on 2018/3/12.
//  Copyright © 2018年 qingtiantree. All rights reserved.
//

#import "FLHomeBodyView.h"
#import "FLHomeBodyViewCell.h"
@implementation FLHomeBodyView

static NSString * ID = @"FLHomeBodyViewCellID";
- (instancetype)initWithFrame:(CGRect)frame collectionViewLayout:(UICollectionViewLayout *)layout{
    
    self = [super initWithFrame:frame collectionViewLayout:layout];
    if (self) {
        [self registerClass:[FLHomeBodyViewCell class] forCellWithReuseIdentifier:ID];
        
        self.showsVerticalScrollIndicator = NO;
        self.showsHorizontalScrollIndicator = NO;
        self.delegate = self;
        self.dataSource = self;
        self.backgroundColor = [UIColor blueColor];
    }
    return self;
}

#pragma mark ------------------------ uicollection delegate

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section{
    return self.titleArray.count;
}

-(void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath{
}

- (__kindof UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath{
    
    FLHomeBodyViewCell *cell  = [collectionView dequeueReusableCellWithReuseIdentifier:ID forIndexPath:indexPath];
    
    cell.classID = [NSString stringWithFormat:@"%@",self.titleArray[indexPath.item]];
    
    cell.backgroundColor = [UIColor colorWithRed:(arc4random() % 256 ) / 255.0  green:(arc4random() % 256 ) / 255.0 blue:(arc4random() % 256 ) / 255.0 alpha:(arc4random() % 256 ) / 255.0 ];
    
    
    
    return cell;
}


- (void)scrollViewWillEndDragging:(UIScrollView *)scrollView withVelocity:(CGPoint)velocity targetContentOffset:(inout CGPoint *)targetContentOffset{
    
    NSLog(@"====当前是第 %lf 页面 ===", targetContentOffset->x / [UIScreen mainScreen].bounds.size.width);
    
    NSInteger page = targetContentOffset->x / [UIScreen mainScreen].bounds.size.width;
    
    if (self.linkageAction) {
        self.linkageAction(page);
    }
}

- (void)setPage:(NSInteger)page{
    
    _page = page;
    
    dispatch_async(dispatch_get_main_queue(), ^{
        
        [self scrollToItemAtIndexPath:[NSIndexPath indexPathForItem:page inSection:0] atScrollPosition:UICollectionViewScrollPositionCenteredHorizontally animated:YES];
        
    });
}

@end
